SystemOrganization addCategory: #'GT-Tests-Inspector'!

TestCase subclass: #GTInspectorDummyExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 17:38'!
allExamplesDummiesProviders
	^ { 
		GTDummyExamples. 
		GTDummyExamplesPragmas. 
		GTDummyExamplesRecursive. 
		GTDummyExamplesWithDependencies. 
		GTDummyExamplesWithExternalDependencies.
		GTDummyExamplesWithExceptions 
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'utils' stamp: 'StefanReichhart 9/12/2015 14:22'!
examplesInClasses: aSelector do: aBlock
	| classes examples |
	self shouldnt: [ classes  := (self perform: aSelector) ] raise: Error.
	classes do: [ :each |
		self shouldnt: [ examples := each gtExamples ] raise: Error.
		examples do: [ :example |
			self shouldnt: [ aBlock value: example ] raise: Error ] ]! !

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 14:36'!
invalidExamplesDummiesProviders
	^ { 
		GTDummyExamplesInvalid.
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 14:41'!
recursiveExamplesDummiesProviders
	^ { 
		GTDummyExamplesRecursive.
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testExists
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: example exists ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:36'!
testInvalidDefinitions
	self examplesInClasses: #invalidExamplesDummiesProviders do: [ :example | 
		self assert: example exists.
		self deny: example isValid ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testIsEquals
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: (example = example) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testIsGTExample
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: example isGTExample ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testMatchesMethod
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: (example matchesMethod: example method) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:40'!
testRecursiveDefinitions
	self examplesInClasses: #recursiveExamplesDummiesProviders do: [ :example | 
		self assert: example exists.
		self assert: example hasValidArguments.
		self assert: example hasValidDependencies.
		self assert: (example method selector = #h or: [ example isValid not ]) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testResult
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self shouldnt: [ example result ] raise: Error.
		self shouldnt: [ example returnValue ] raise: Error.
		self shouldnt: [ example detachResultFromSystem ] raise: Error.
		self shouldnt: [ example result ] raise: Error.
		self shouldnt: [ example returnValue ] raise: Error. ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testRun
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self shouldnt: [ example run ] raise: Error ]! !

TestCase subclass: #GTInspectorExamplesTest
	instanceVariableNames: 'pragmas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTInspectorExamplesTest methodsFor: 'running' stamp: 'StefanReichhart 11/16/2015 20:15'!
allExamplesClasses
	" IMPORTANT NOTICE 
	1) We expicitly exclude examples from Roassal and Woden. Running all of those examples at once will severely slow down all tests and eventually cause segmentation faults - crash of image. This is not a fault/bug of GTExample - it happens also if the GTExample-wrapper is not used at all !! "
	^ ((Object withAllSubclasses 
		reject: [ :each | 
			(each name beginsWith: 'RT') 
				or: [ (each name beginsWith: 'RW')
					or: [ each name beginsWith: 'GTDummy' ] ] ]) 
		sort: [ :a :b | a name <= b name ])! !

!GTInspectorExamplesTest methodsFor: 'running' stamp: 'StefanReichhart 11/16/2015 20:15'!
checkAllPresentationsOf: exampleToTest
	| browser window |
	(Pragma allNamed: #gtInspectorPresentationOrder: from: exampleToTest class to: Object) do: [ :eachPragma | 
		browser := GLMWrapper new.
		[	browser
				show: [ :composite | 
					(eachPragma selector findTokens: $:) size = 1
						ifTrue: [ exampleToTest perform: eachPragma selector with: composite ].
					(eachPragma selector findTokens: $:) size = 2
						ifTrue: [ exampleToTest perform: eachPragma selector with: composite with: browser ] ].
			window := browser openOn: exampleToTest ] 
				on: Error 
				do: [
					window ifNotNil: [ window delete ].
					self fail: (eachPragma method gtDisplayString, ' for ', exampleToTest gtDisplayString)  ].
		window ifNotNil: [ window delete ] ]! !

!GTInspectorExamplesTest methodsFor: 'running' stamp: 'StefanReichhart 11/14/2015 09:57'!
pragmasFor: exampleToTest
	^ pragmas 
		at: exampleToTest class 
		ifAbsentPut: [ Pragma allNamed: #gtInspectorPresentationOrder: from: exampleToTest class to: Object ]! !

!GTInspectorExamplesTest methodsFor: 'running' stamp: 'StefanReichhart 11/16/2015 20:29'!
setUp
	super setUp.
	
	pragmas := IdentityDictionary new.
	GTExampleOrganizer instance reset.
	GTExampleOrganizer stop.
	
	Smalltalk garbageCollect! !

!GTInspectorExamplesTest methodsFor: 'running' stamp: 'StefanReichhart 11/16/2015 20:29'!
tearDown
	super tearDown.
	
	pragmas := nil.
	GTExampleOrganizer instance reset.
	GTExampleOrganizer start.
	
	Smalltalk garbageCollect! !

!GTInspectorExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 11/16/2015 20:08'!
testAllExamples
	self allExamplesClasses
		do: [ :eachClass | 
			eachClass gtExamples do: [ :exampleToTest | 
				self checkAllPresentationsOf: exampleToTest ] ]! !

!GTInspectorExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 11/14/2015 09:54'!
testGlobals
	{ Smalltalk . RBMessageNode . Trait . TClass . TBehavior . GTInspector . Object . Class . CompiledMethod } 
		do: [ :each | self checkAllPresentationsOf: each ]! !

TestCase subclass: #GTInspectorVariableValuePairsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:33'!
testArrayPairs41
	| pairs |
	
	pairs := (1 to: 41) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 41.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].
	
	self assert: ((pairs collect: #key) = (1 to: 41) asOrderedCollection).! !

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:33'!
testArrayPairs42
	| pairs |
	
	pairs := (1 to: 42) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 42.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].
	
	self assert: ((pairs collect: #key) = (1 to: 42) asOrderedCollection).! !

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:34'!
testArrayPairs43
	| pairs |
	
	pairs := (1 to: 43) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 42.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].
	
	self assert: ((pairs collect: #key) = ((1 to: 21) asOrderedCollection addAll: (23 to: 43) asOrderedCollection; yourself)).! !

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:33'!
testArrayPairsLong
	| pairs |
	
	pairs := (1 to: 100) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 42.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].
	
	self assert: ((pairs collect: #key) = ((1 to: 21) asOrderedCollection addAll: (80 to: 100) asOrderedCollection; yourself)).! !

!GTInspectorVariableValuePairsTest methodsFor: 'object' stamp: 'TommasoDalSasso 1/30/2015 17:21'!
testArrayPairsSmall
	| pairs |
	
	pairs := (1 to: 10) asArray gtInspectorVariableValuePairs.
	self assert: pairs size = 10.
	(pairs collect: #key) allSatisfy: [ :e | (pairs at: e) = e ].! !

!GTInspectorVariableValuePairsTest methodsFor: 'context' stamp: 'TommasoDalSasso 1/30/2015 18:03'!
testContextPairs
	| pairs x tempVariables indexVariables instVariables |
	
	x:=42.
	pairs := [:y| y+1+x ] asContext gtInspectorVariableValuePairs withIndexCollect: [ :e :i | i -> e].	
	
	tempVariables := pairs select: [ :e | e value key asString beginsWith: '[' ].
	indexVariables := pairs select: [ :e | e value key isInteger ].
	instVariables := pairs select: [ :e | e value key isSymbol ].
	
	self assert: (tempVariables sort last key) < (indexVariables sort first key).
	self assert: (indexVariables sort last key) < (instVariables sort first key).! !

!GTInspectorVariableValuePairsTest methodsFor: 'float' stamp: 'TommasoDalSasso 1/30/2015 17:39'!
testFloatPairs
	| pairs |
	
	pairs := 4.2 gtInspectorVariableValuePairs.
	self assert: pairs size = 2.
	
	self assert: (pairs first = ('1' -> 1074842828)).
	self assert: (pairs second = ('2' -> 3435973837)).! !

GTExampleTestCase subclass: #GTToolkitExampleTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTToolkitExampleTestCase methodsFor: 'tests' stamp: 'StefanReichhart 9/26/2015 11:32'!
testExamplesDebugger
	self runExampleContainers: (self packages: { 'GT-Debugger*' })! !

!GTToolkitExampleTestCase methodsFor: 'tests' stamp: 'StefanReichhart 9/26/2015 10:52'!
testExamplesInspector
	self runExampleContainers: (self packages: { 'GT-Inspector*' })! !

!GTToolkitExampleTestCase methodsFor: 'tests' stamp: 'StefanReichhart 9/26/2015 10:52'!
testExamplesPlayground
	self runExampleContainers: (self packages: { 'GT-Playground*' })! !

!GTToolkitExampleTestCase methodsFor: 'tests' stamp: 'StefanReichhart 9/26/2015 10:52'!
testExamplesSpotter
	self runExampleContainers: (self packages: { 'GT-Spotter*' })! !

Object subclass: #GTInspectorExamplesManualTest
	instanceVariableNames: 'allFailures allClasses allTestedClasses allUntestedClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTInspectorExamplesManualTest class methodsFor: 'public' stamp: 'StefanReichhart 11/14/2015 14:45'!
reset
	FileSystem workingDirectory allFiles 
		select: [ :each | each basename beginsWith: 'gtExamples' ]
		thenDo: [ :each | each delete ]! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 14:52'!
basicRunClasses
	 self runClasses: allUntestedClasses ! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 13:44'!
basicRunExample: anExample
	self checkAllPresentationsOf: anExample onError: [ :aPragma :anException | 
		allFailures add: anExample method.
		self printException: anException forExample: anExample withPragma: aPragma ] ! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 14:49'!
basicRunFailures
	" self new runFailures "

	(allFailures := self readFailuresFromFile: (FileSystem workingDirectory / 'gtExamplesAllFailures.txt')) 
		do: [ :each |
			each gtExamples do: [ :example |
				self runExample: example ] ]
		displayingProgress: 'Running ', allFailures size asString, ' failures ...'! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 11:20'!
checkAllPresentationsOf: exampleToTest onError: aBlock
	| browser window |
	(Pragma allNamed: #gtInspectorPresentationOrder: from: exampleToTest class to: Object) do: [ :eachPragma | 
		browser := GLMWrapper new.
		[	browser
				show: [ :composite | 
					(eachPragma selector findTokens: $:) size = 1
						ifTrue: [ exampleToTest perform: eachPragma selector with: composite ].
					(eachPragma selector findTokens: $:) size = 2
						ifTrue: [ exampleToTest perform: eachPragma selector with: composite with: browser ] ].
			window := browser openOn: exampleToTest ] 
				on: Error 
				do: [ :exception |
					window ifNotNil: [ window delete ].
					aBlock value: eachPragma value: exception ].
		window ifNotNil: [ window delete ] ]! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 14:46'!
filenameFor: anExample
	^ ((('gtExamplesFailure_' anExample method gtDisplayString		 
			copyReplaceAll: '>' with: '_') 
			copyReplaceAll: ':' with: '.') 
			copyReplaceAll: ' ' with: '') 
			copyReplaceAll: '#' with: ''! !

!GTInspectorExamplesManualTest methodsFor: 'initialization' stamp: 'StefanReichhart 11/14/2015 14:49'!
initialize
	| fileWithAllClasses fileWithAllTestedClasses |
	super initialize.
		
	" prepare all classes "
	allClasses := {}.
	fileWithAllClasses := FileSystem workingDirectory / 'gtExamplesAllClasses.txt'.
	fileWithAllClasses exists ifTrue: [ 
		allClasses := self readClassesFromFile: fileWithAllClasses ].
	allClasses isEmptyOrNil ifTrue: [
		| streamWithAllClasses |
		allClasses := SystemNavigation default allClassesAndTraits sort: [ :a :b | a name <= b name ].
		streamWithAllClasses := fileWithAllClasses writeStream.
		allClasses do: [ :each | streamWithAllClasses nextPutAll: each name; cr. ].
		streamWithAllClasses flush; close. ].

	" prepare tested classes "
	allTestedClasses := {}.
	fileWithAllTestedClasses := FileSystem workingDirectory / 'gtExamplesAllTestedClasses.txt'.
	fileWithAllTestedClasses exists ifTrue: [ 
		allTestedClasses := self readClassesFromFile: fileWithAllTestedClasses ].
	
	" prepare untested classes "
	allUntestedClasses := (allClasses difference: allTestedClasses) sort: [ :a :b | a name <= b name ].
	
	" prepare failures "
	allFailures := self readFailuresFromFile: (FileSystem workingDirectory / 'gtExampleAllFailures.txt').! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 14:50'!
printException: anException forExample: anExample withPragma: aPragma
	(FileSystem workingDirectory / 'gtExamplesAllFailures.txt') writeStream 
		setToEnd; cr;
		nextPutAll: anExample method gtDisplayString; cr;
		flush;
		close.
	(FileSystem workingDirectory / (self filenameFor: anExample)) writeStream 
		truncate;
		nextPutAll: anExample gtDisplayString; cr;
		nextPutAll: aPragma gtDisplayString; cr;
		nextPutAll: anException asString; cr;
		nextPutAll: '--------------------------------------------------------------------------------'; cr;
		nextPutAll: (String streamContents: [ :stream | 
							anException signalerContext ifNotNil: [ :context | 
								context debugStackOn: stream ] ] );
		flush;
		close! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 13:56'!
readClassesFromFile: aFile
	aFile exists ifFalse: [ ^ OrderedCollection new ].
	^ ((aFile readStream contents splitOn: String cr) 
		collect: [ :each | [ Smalltalk classNamed: each trimBoth ] on: Error do: [ nil ] ]) 
		reject: [ :each | each isNil ]! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 13:56'!
readFailuresFromFile: aFile
	aFile exists ifFalse: [ ^ OrderedCollection new ].
	^ (((aFile readStream contents splitOn: String cr)
		collect: [ :each | [ Compiler evaluate: each trimBoth ] on: Error do: [ nil ] ])
		reject: [ :each | each isNil ]) asSet asOrderedCollection! !

!GTInspectorExamplesManualTest methodsFor: 'public' stamp: 'StefanReichhart 11/14/2015 14:52'!
run
	" self new run "
	
	self run: [ self basicRunClasses ]! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 13:58'!
run: aBlock
	
	[ GTExampleOrganizer instance stop. aBlock value ]
		ensure: [ GTExampleOrganizer instance start ].
	
	self verify! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 14:50'!
runClasses: aCollectionOfClasses
	aCollectionOfClasses 
		do: [ :class | 
			class gtExamples
				do: [ :example | self runExample: example ]
				displayingProgress: class name.
			(FileSystem workingDirectory / 'gtExamplesAllTestedClasses.txt') writeStream setToEnd; cr; nextPutAll: class name; flush; close ]
		displayingProgress: 'Running examples of ', aCollectionOfClasses size asString, ' classes ...'.! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 13:44'!
runExample: anExample
	[ self basicRunExample: anExample ]
		on: Error
		do: [ :exception | 
			allFailures add: anExample method.
			self printException: exception forExample: anExample withPragma: nil ] ! !

!GTInspectorExamplesManualTest methodsFor: 'public' stamp: 'StefanReichhart 11/14/2015 13:58'!
runFailures
	" self new runFailures "
	
	self run: [ self basicRunFailures ]! !

!GTInspectorExamplesManualTest methodsFor: 'private' stamp: 'StefanReichhart 11/14/2015 13:32'!
verify
	self assert: allFailures isEmptyOrNil description: (String streamContents: [ :stream |
		allFailures do: [ :each | 
			stream nextPutAll: each gtDisplayString; cr ] ] )! !

GLMMorphicTest subclass: #GTUnprintableObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Inspector'!

!GTUnprintableObjectTest commentStamp: '<historical>' prior: 0!
GTUnprintableObjectTest is a test that checks that print string does not trigger an error in the inspector.!

!GTUnprintableObjectTest methodsFor: 'printing' stamp: 'TudorGirba 5/25/2012 17:13'!
printString
	"Simulate an error in printString"
	1/0! !

!GTUnprintableObjectTest methodsFor: 'tests' stamp: 'TudorGirba 5/25/2012 17:12'!
testInspectDoesNotCrash
	window := GTInspector openOn: self class new ! !
